// porshe.cc --- A simple Porshe class.

// Author:        Didier Verna <didier@lrde.epita.fr>
// Maintainer:    Didier Verna <didier@lrde.epita.fr>
// Created:       Wed Oct 15 10:05:47 2008
// Last Revision: Mon Apr  6 16:04:15 2009


// Commentary:

// Contents management by FCM version 0.1.


// Code:

#include <iostream>
#include <ostream>
#include <vector>

// A wheel
struct Wheel {
  Wheel () { std::cout << "Created a wheel." << std::endl; };
};

// A body with 4 wheels
struct Body
{
  Body ()
  {
    for (int i=0; i<4; i++)
      _wheels.push_back (Wheel());
    std::cout << "Created a body." << std::endl;
  };

  std::vector<Wheel> _wheels;
};

// An engine
struct Engine
{
  Engine () { std::cout << "Created an engine." << std::endl; };
};

// A Porshe with a 4 wheels body and an engine
struct Porshe
{
  Porshe () { std::cout << "Created a Porshe." << std::endl; };

  Body _body;
  Engine _engine;
};


int main (int argc, char *argv[])
{
  Porshe porshe;
}

// porshe.cc ends here
